/*
**	ui.c
*/
#include "mpeg.h"
#include "disp.h"
#define NB 6
extern double cur;
extern void get_psf(int,int);
/*
** externs from io.c
*/
extern int wx,wy;
extern int wix,wiy;
extern int fg_pix;
extern int lbp;
extern int learn;
extern int grid;
extern int incx,incy;
extern int scr;
extern XEvent pe;
extern Window rt;
extern Visual *vis;
extern int pause;
extern int step;
extern xoff,yoff;
extern peak_pos_x;
extern peak_pos_y;
/*
extern int (*disp)();
*/
/*
**
*/
static char cmp3[4][20]={ "brilliance","contrast","limit","hue"};
static double cmp3v[4]={ 1, 1, 1, 1};
int cost= 1<<16, sint= 0;
int bright= 0, contrast= 1<<16;
static int cmp3s=0;
static char aria[4][NB][20]={
{"Light mode","Color Trim","Synchronize","Pause","Step","Exit"},
{"Light","Trim","Sync","Pause","Step","Exit"},
{"Lt","Tm","Sc","Ps","St","Ex"}
	};
static char dpd[10][4]={ "0","1","2","3","4","5","6","7","G","F"};
static char dpo[2][4]={ "off","on" };
static char dpc[4][6]={ "asis","color","off","gray" };
static char dps[8][6]={ "free","sync","sync2","sync3",
"sync4","sync5","sync6","sync7" };
double grid_exp;
static char scale[3][20]={ "Scale up/down", "Scale", "Scl" };
static int grab;

mkgrid() {
	int i,k=0,sp=wy*13/16;
	if(wx<400) k= 1;
	if(wx<200) k= 2;
	if(wx<48||wy<32)return;

	hline(sp,0,wx);
	hline(wy-1,0,wx);
	vline(wx-1,sp,wy);
	strimg(6,2,scale[k]);
	strimg(6,16,dpd[x2]);
	for(i=0;i<NB;i++){
		vline(wx*i/NB,sp,wy);
	 	strimg(wx*i/NB+6,sp,aria[k][i]);
		}
	sp+= 16;
	strimg(6,sp,dpc[bgc]);
	strimg(wx/NB+6,sp,dpo[cmp]);
	strimg(wx*2/NB+6,sp,dps[sync]);
	if(cmp && wid==0){
		hline(wy*11/16,0,wx);
		hline(wy*12/16,0,wx);
		vline((int)(wx*cmp3v[cmp3s]/2.),wy*12/16-8,wy*12/16+8);
		for(i=0;i<20;i++){
			vline(wx*i/20,wy*12/16-2,wy*12/16+2);
			}
		vline(wx*10/20,wy*12/16-4,wy*12/16+4);
		vline(wx/8, wy*11/16, wy*13/16);
		strimg(6,wy*11/16,cmp3[cmp3s]);
		}
	}

hline(y,x0,x1) {
	int x;
	if(lbp==0) for(x= x0; x<x1; x+=2) dd[wix*y+x]= fg_pix;
	else if(lbp==1)
	{Us *p= (Us *)dd; for(x= x0; x<x1; x+=2) p[wix*y+x]= fg_pix;}
	else if(lbp==2)
	{Ui *p= (Ui *)dd; for(x= x0; x<x1; x+=2) p[wix*y+x]= fg_pix;}
	}
vline(x,y0,y1) {
	int y;
	if(lbp==0) for(y= y0; y<y1; y+=2)dd[wix*y+x]= fg_pix;
	else if(lbp==1)
	{Us *p= (Us *)dd; for(y= y0; y<y1; y+=2)p[wix*y+x]= fg_pix;}
	else if(lbp==2)
	{Ui *p= (Ui *)dd; for(y= y0; y<y1; y+=2)p[wix*y+x]= fg_pix;}
	}

strimg(x,y,str)
Uc *str;
	{
	int c,i,j,k,fc;
	for(i=0;i<strlen(str);i++){
		c= str[i];
		for(j=0;j<15&&j<wy-y-3;j++){
			if(lbp==0){
			char *p= dd+(y+j+3)*wix+x+i*9;
			fc= font[c][j+2];
			for(k=0;k<8;k++) if(fc&(1<<k))p[k]= fg_pix;
			}
			else if(lbp==1){
			Us *p= (Us *)dd+(y+j+3)*wix+x+i*9;
			fc= font[c][j+2];
			for(k=0;k<8;k++) if(fc&(1<<k))p[k]= fg_pix;
			}
			else if(lbp==2){
			Ui *p= (Ui *)dd+(y+j+3)*wix+x+i*9;
			fc= font[c][j+2];
			for(k=0;k<8;k++) if(fc&(1<<k))p[k]= fg_pix;
			}
			}
		}
	}

button_off() { grab= 0; }
button_on(char*sif)
	{
	int x,y,d=1;

	x= pe.xbutton.x;
	y= pe.xbutton.y;

	peak_pos_x= x;
	peak_pos_y= y;
	get_psf(x,y);
	printf("(%d,%d)\n",x,y);
	return;
	/*
	printf("%d %d dx=%d\n",x,y,dx);
	{
		int i,j;
		for(j=0;j<16;j++){
			printf("\n");
			for(i=0;i<16;i++)
				printf("%3d,",(Uc)sif[(y+j-8)*dx+x+i-8]);
		}
	}
	printf("\n");
	*/

	grid_exp= cur+3.0;
	if(grid==0){ grid= 1; color_map_set(0,1); return; }


	
	if(pe.xbutton.button==Button3)d= -1;

	if(y<wy*11/16 || (wid && y<wy*13/16)){ regular_size(d); return; }
	if(y<wy*13/16 && wid==0){
		if(cmp){
			if(x<wx/8){
				cmp3s+= d;
				if(ddt==FullColor) cmp3s&= 1;
				 else		   cmp3s&= 3;
				}
			 else  grab= 1;
			}
		 else regular_size(d);
		return;
		}

	if(ddt==7 && x<wx/NB/2){ learn++; learn&=1; return; }
	switch(x*NB/wx){
	/*
	case 0: bgc+= d; bgc&= 3; color_map_set(1,0); return;
	case 1: cmp+= d; cmp&= 1; break;
	*/
	case 0: xoff+= d; break;
	case 1: yoff+= d; break;

	case 2: sync+=d; sync&=7; return;
	case 3: pause+=d; pause&= 1; return;
	case 4: step+= d; return;
	case 5: exit(0);
		}
	if(ddt==FullColor)init_cl(ddt,x2);
	 else   color_map_set(0,0);
	}


static int rs=0;
static int x2t;
regular_size(d)
	{
	rs= 1;
	x2t= x2+d;
	if(x2t==0) x2t= 4;
	if(x2t==5 || x2t==-1) x2t= 1;
	XResizeWindow(dpy,w1,ddx*x2t+incx,ddy*x2t+incy);
	}

lever()
	{
	int x,y;
	grid_exp= cur+3.0;
	x= pe.xmotion.x;
	y= pe.xmotion.y;
	if(grab && y>=wy*11/16 && y<wy*13/16){
		cmp3v[cmp3s]= 2.*x/wx;
		switch(cmp3s){
			case 0: bright= (cmp3v[0]-1.0)*(1<<22); break;
			case 1: contrast= cmp3v[1]*(1<<16); break;
			case 2: case 3:
				cost= cmp3v[2]*cos(cmp3v[3]-1.0)*(1<<16);
				sint= cmp3v[2]*sin(cmp3v[3]-1.0)*(1<<16);
			}
		if(ddt==FullColor)init_cl(ddt,x2);
		else color_map_set(0,0);
		}
	}

var_size()
	{
	int x,y,i;

	x= pe.xconfigure.width-incx;
	y= pe.xconfigure.height-incy;

	if(x==wx && y==wy)return;

	for(x2=5;x2>0;x2--)if(x==ddx*x2&&y==ddy*x2)break;
	if(rs){ x2= x2t; rs= 0; }
	winw= wx= x; winh= wy= y;

	if(x2){ x= dx*x2; y= ddy*x2; }
	else { x= x*dx/ddx; }

	if(x&3)x+= (4-x&3);	/* Image size shold be 4x2's multiple */
	if(y&1)y++;	/* for variable size dithers */
	wix= x; wiy= y;
	init_cl(ddt,x2);
	create_image(x,y);
	}

XColor xc[CN];
color_map_set(bgonly,gdonly)
	{
	int j,y,u,v,r,g,b;
	int offuv,begin,end;
	static int new=1;

	if(ddt==FullColor)return;
	if(new){
		new= 0;
		c1.flags= DoRed|DoGreen|DoBlue;
		dmap= DefaultColormap(dpy,scr);
		if(wid) {
			XWindowAttributes wa;
			XGetWindowAttributes(dpy,wid,&wa);
			map= wa.colormap;
			}
		else map=  XCreateColormap(dpy,rt,vis,1);
		}

	if(gdonly) { begin= fg_pix; end= fg_pix+1; }
	else if(bgonly){ begin= 0; end= ICN; }
	else	       { begin= 0; end= CN; }

	for(j=begin;j<end;j++){
		xc[j].pixel= j;
		xc[j].flags= DoRed|DoGreen|DoBlue;
		if(j<ICN && bgc!=1){
			if(bgc==0) XQueryColor(dpy,dmap,&xc[j]);
			if(bgc==2) xc[j].red=xc[j].green=xc[j].blue= 0;
			if(bgc==3) xc[j].red=xc[j].green=xc[j].blue= j<<11;
			}
		else switch(ddt){
	case 8: r=g=b=j; goto save_cm;
	case 0: 
		r= (j&0xe0)+16;
		g= ((j&0x1c)<<3)+16;
		b= ((j&3)<<6)+32;
	save_cm: cmr[j]= r; cmg[j]= g; cmb[j]= b;
		Rgbrgb()
		if(j==ICN) r=g=b=0;
		xc[j].red= r<<8; xc[j].green= g<<8; xc[j].blue=  b<<8;
		}
		if(j==fg_pix && grid) xc[j].red=xc[j].green=xc[j].blue= 255<<8;
		}
	if(gdonly) XStoreColor(dpy,map,&xc[fg_pix]);
	else if(bgonly) XStoreColors(dpy,map,xc,ICN);
	else	        XStoreColors(dpy,map,xc,CN);
	}

